public void addExceptionHandler(int startLabel,int endLabel,int handlerLabel,String catchClassName){
  if ((startLabel & 0x80000000) != 0x80000000)   throw new IllegalArgumentException("Bad startLabel");
  if ((endLabel & 0x80000000) != 0x80000000)   throw new IllegalArgumentException("Bad endLabel");
  if ((handlerLabel & 0x80000000) != 0x80000000)   throw new IllegalArgumentException("Bad handlerLabel");
  short catch_type_index=(catchClassName == null) ? 0 : itsConstantPool.addClass(catchClassName);
  ExceptionTableEntry newEntry=new ExceptionTableEntry(startLabel,endLabel,handlerLabel,catch_type_index);
  int N=itsExceptionTableTop;
  if (N == 0) {
    itsExceptionTable=new ExceptionTableEntry[ExceptionTableSize];
  }
 else   if (N == itsExceptionTable.length) {
    ExceptionTableEntry[] tmp=new ExceptionTableEntry[N * 2];
    System.arraycopy(itsExceptionTable,0,tmp,0,N);
    itsExceptionTable=tmp;
  }
  itsExceptionTable[N]=newEntry;
  itsExceptionTableTop=N + 1;
}
