/** 
 * Break (possibly labeled)
 */
Node createBreak(Node breakStatement,int lineno){
  Node.Jump n=new Node.Jump(Token.BREAK,lineno);
  Node.Jump jumpStatement;
  int t=breakStatement.getType();
  if (t == Token.LOOP || t == Token.LABEL) {
    jumpStatement=(Node.Jump)breakStatement;
  }
 else   if (t == Token.BLOCK && breakStatement.getFirstChild().getType() == Token.SWITCH) {
    jumpStatement=(Node.Jump)breakStatement.getFirstChild();
  }
 else {
    throw Kit.codeBug();
  }
  n.setJumpStatement(jumpStatement);
  return n;
}
