/** 
 * Get class loader-like object that can be used to define classes with the given security context.
 * @param parentLoader parent class loader to delegate search for classesnot defined by the class loader itself
 * @param securityDomain some object specifying the securitycontext of the code that is defined by the returned class loader.
 */
public abstract GeneratedClassLoader createClassLoader(ClassLoader parentLoader,Object securityDomain);
