Node createIncDec(int nodeType,boolean post,Node child){
  child=makeReference(child);
  if (child == null) {
    String msg;
    if (nodeType == Token.DEC) {
      msg="msg.bad.decr";
    }
 else {
      msg="msg.bad.incr";
    }
    parser.reportError(msg);
    return null;
  }
  int childType=child.getType();
switch (childType) {
case Token.NAME:
case Token.GETPROP:
case Token.GETELEM:
case Token.GET_REF:
{
      Node n=new Node(nodeType,child);
      int incrDecrMask=0;
      if (nodeType == Token.DEC) {
        incrDecrMask|=Node.DECR_FLAG;
      }
      if (post) {
        incrDecrMask|=Node.POST_FLAG;
      }
      n.putIntProp(Node.INCRDECR_PROP,incrDecrMask);
      return n;
    }
}
throw Kit.codeBug();
}
