/** 
 * Create loop node. The parser will later call createWhile|createDoWhile|createFor|createForIn to finish loop generation.
 */
Node createLoopNode(Node loopLabel,int lineno){
  Node.Jump result=new Node.Scope(Token.LOOP,lineno);
  if (loopLabel != null) {
    ((Node.Jump)loopLabel).setLoop(result);
  }
  return result;
}
