void defineSymbol(int declType,String name){
  Node.Scope definingScope=currentScope.getDefiningScope(name);
  Node.Scope.Symbol symbol=definingScope != null ? definingScope.getSymbol(name) : null;
  boolean error=false;
  if (symbol != null && (symbol.declType == Token.CONST || declType == Token.CONST)) {
    error=true;
  }
 else {
switch (declType) {
case Token.LET:
      if (symbol != null && definingScope == currentScope) {
        error=symbol.declType == Token.LET;
      }
    currentScope.putSymbol(name,new Node.Scope.Symbol(declType,name));
  break;
case Token.VAR:
case Token.CONST:
case Token.FUNCTION:
if (symbol != null) {
  if (symbol.declType == Token.VAR)   addStrictWarning("msg.var.redecl",name);
 else   if (symbol.declType == Token.LP) {
    addStrictWarning("msg.var.hides.arg",name);
  }
}
 else {
  currentScriptOrFn.putSymbol(name,new Node.Scope.Symbol(declType,name));
}
break;
case Token.LP:
if (symbol != null) {
addWarning("msg.dup.parms",name);
}
currentScriptOrFn.putSymbol(name,new Node.Scope.Symbol(declType,name));
break;
default :
throw Kit.codeBug();
}
}
if (error) {
addError(symbol.declType == Token.CONST ? "msg.const.redecl" : symbol.declType == Token.LET ? "msg.let.redecl" : symbol.declType == Token.VAR ? "msg.var.redecl" : symbol.declType == Token.FUNCTION ? "msg.fn.redecl" : "msg.parm.redecl",name);
}
}
