public static boolean deleteObjectElem(Scriptable target,Object elem,Context cx){
  boolean result;
  if (target instanceof XMLObject) {
    XMLObject xmlObject=(XMLObject)target;
    result=xmlObject.ecmaDelete(cx,elem);
  }
 else {
    String s=toStringIdOrIndex(cx,elem);
    if (s == null) {
      int index=lastIndexResult(cx);
      result=ScriptableObject.deleteProperty(target,index);
    }
 else {
      result=ScriptableObject.deleteProperty(target,s);
    }
  }
  return result;
}
