private void emitDirectConstructor(ClassFileWriter cfw,OptFunctionNode ofn){
  cfw.startMethod(getDirectCtorName(ofn.fnode),getBodyMethodSignature(ofn.fnode),(short)(ClassFileWriter.ACC_STATIC | ClassFileWriter.ACC_PRIVATE));
  int argCount=ofn.fnode.getParamCount();
  int firstLocal=(4 + argCount * 3) + 1;
  cfw.addALoad(0);
  cfw.addALoad(1);
  cfw.addALoad(2);
  cfw.addInvoke(ByteCode.INVOKEVIRTUAL,"org/mozilla/javascript/BaseFunction","createObject","(Lorg/mozilla/javascript/Context;" + "Lorg/mozilla/javascript/Scriptable;" + ")Lorg/mozilla/javascript/Scriptable;");
  cfw.addAStore(firstLocal);
  cfw.addALoad(0);
  cfw.addALoad(1);
  cfw.addALoad(2);
  cfw.addALoad(firstLocal);
  for (int i=0; i < argCount; i++) {
    cfw.addALoad(4 + (i * 3));
    cfw.addDLoad(5 + (i * 3));
  }
  cfw.addALoad(4 + argCount * 3);
  cfw.addInvoke(ByteCode.INVOKESTATIC,mainClassName,getBodyMethodName(ofn.fnode),getBodyMethodSignature(ofn.fnode));
  int exitLabel=cfw.acquireLabel();
  cfw.add(ByteCode.DUP);
  cfw.add(ByteCode.INSTANCEOF,"org/mozilla/javascript/Scriptable");
  cfw.add(ByteCode.IFEQ,exitLabel);
  cfw.add(ByteCode.CHECKCAST,"org/mozilla/javascript/Scriptable");
  cfw.add(ByteCode.ARETURN);
  cfw.markLabel(exitLabel);
  cfw.addALoad(firstLocal);
  cfw.add(ByteCode.ARETURN);
  cfw.stopMethod((short)(firstLocal + 1));
}
