/** 
 * A general block of code is examined statement by statement. If any statement (even compound ones) returns in all branches, then subsequent statements are not examined.
 * @return logical OR of END_* flags
 */
private int endCheckBlock(){
  Node n;
  int rv=END_DROPS_OFF;
  for (n=first; ((rv & END_DROPS_OFF) != 0) && n != null; n=n.next) {
    rv&=~END_DROPS_OFF;
    rv|=n.endCheck();
  }
  return rv;
}
