private Node expr(boolean inForInit) throws IOException, ParserException {
  Node pn=assignExpr(inForInit);
  while (matchToken(Token.COMMA)) {
    decompiler.addToken(Token.COMMA);
    if (compilerEnv.isStrictMode() && !pn.hasSideEffects())     addStrictWarning("msg.no.side.effects","");
    if (peekToken() == Token.YIELD) {
      reportError("msg.yield.parenthesized");
    }
    pn=nf.createBinary(Token.COMMA,pn,assignExpr(inForInit));
  }
  return pn;
}
