static Callable getCallable(Scriptable thisObj){
  Callable function;
  if (thisObj instanceof Callable) {
    function=(Callable)thisObj;
  }
 else {
    Object value=thisObj.getDefaultValue(ScriptRuntime.FunctionClass);
    if (!(value instanceof Callable)) {
      throw ScriptRuntime.notFunctionError(value,thisObj);
    }
    function=(Callable)value;
  }
  return function;
}
