/** 
 * Get dynamic security domain that allows an action only if it is allowed by the current Java stack and <i>securityDomain</i>. If <i>securityDomain</i> is null, return domain representing permissions allowed by the current stack.
 */
public abstract Object getDynamicSecurityDomain(Object securityDomain);
