/** 
 * Provides a default {@link org.mozilla.javascript.xml.XMLLib.Factory XMLLib.Factory}to be used by the <code>Context</code> instances produced by this factory. See  {@link Context#getE4xImplementationFactory} for details.May return null, in which case E4X functionality is not supported in Rhino. The default implementation now prefers the DOM3 E4X implementation.
 */
protected org.mozilla.javascript.xml.XMLLib.Factory getE4xImplementationFactory(){
  if (isDom3Present()) {
    return org.mozilla.javascript.xml.XMLLib.Factory.create("org.mozilla.javascript.xmlimpl.XMLLibImpl");
  }
 else   if (Kit.classOrNull("org.apache.xmlbeans.XmlCursor") != null) {
    return org.mozilla.javascript.xml.XMLLib.Factory.create("org.mozilla.javascript.xml.impl.xmlbeans.XMLLibImpl");
  }
 else {
    return null;
  }
}
