public static Object getObjectProp(Scriptable obj,String property,Context cx){
  if (obj instanceof XMLObject) {
    XMLObject xmlObject=(XMLObject)obj;
    return xmlObject.ecmaGet(cx,property);
  }
  Object result=ScriptableObject.getProperty(obj,property);
  if (result == Scriptable.NOT_FOUND) {
    if (cx.hasFeature(Context.FEATURE_STRICT_MODE)) {
      Context.reportWarning(ScriptRuntime.getMessage1("msg.ref.undefined.prop",property));
    }
    result=Undefined.instance;
  }
  return result;
}
