/** 
 * The instanceof operator.
 * @return a instanceof b
 */
public static boolean instanceOf(Object a,Object b,Context cx){
  if (!(b instanceof Scriptable)) {
    throw typeError0("msg.instanceof.not.object");
  }
  if (!(a instanceof Scriptable))   return false;
  return ((Scriptable)b).hasInstance((Scriptable)a);
}
