/** 
 * Check whether the name is in the list of names of objects forcing the creation of activation objects.
 * @param name the name of the object to test
 * @return true if an function activation object is needed.
 */
public final boolean isActivationNeeded(String name){
  return activationNames != null && activationNames.containsKey(name);
}
