private Node let(boolean isStatement) throws IOException, ParserException {
  mustMatchToken(Token.LP,"msg.no.paren.after.let");
  decompiler.addToken(Token.LP);
  Node result=nf.createScopeNode(Token.LET,ts.getLineno());
  pushScope(result);
  try {
    Node vars=variables(false,true,Token.LET);
    nf.addChildToBack(result,vars);
    mustMatchToken(Token.RP,"msg.no.paren.let");
    decompiler.addToken(Token.RP);
    if (isStatement && peekToken() == Token.LC) {
      consumeToken();
      decompiler.addEOL(Token.LC);
      nf.addChildToBack(result,statements(null));
      mustMatchToken(Token.RC,"msg.no.curly.let");
      decompiler.addToken(Token.RC);
    }
 else {
      result.setType(Token.LETEXPR);
      nf.addChildToBack(result,expr(false));
      if (isStatement) {
        result=nf.createExprStatement(result,ts.getLineno());
      }
    }
  }
  finally {
    popScope();
  }
  return result;
}
