/** 
 * Create new  {@link Context} instance to be associated with the currentthread. This is a callback method used by Rhino to create  {@link Context}instance when it is necessary to associate one with the current execution thread. <tt>makeContext()</tt> is allowed to call {@link Context#seal(Object)} on the result to prevent{@link Context} changes by hostile scripts or applets.
 */
protected Context makeContext(){
  return new Context(this);
}
