private Node matchJumpLabelName() throws IOException, ParserException {
  Node label=null;
  int tt=peekTokenOrEOL();
  if (tt == Token.NAME) {
    consumeToken();
    String name=ts.getString();
    decompiler.addName(name);
    if (labelSet != null) {
      label=(Node)labelSet.get(name);
    }
    if (label == null) {
      reportError("msg.undef.label");
    }
  }
  return label;
}
