/** 
 * Returns whether or not the bits in the mask have changed to all set.
 * @param before bits before change
 * @param after bits after change
 * @param mask mask for bits
 * @return true if all the bits in the mask are set in "after" but not "before"
 */
private static final boolean nowAllSet(int before,int after,int mask){
  return ((before & mask) != mask) && ((after & mask) == mask);
}
