/** 
 * Put a value that can later be retrieved using a given key. <p>
 * @param key the key used to index the value
 * @param value the value to save
 */
public final void putThreadLocal(Object key,Object value){
  if (sealed)   onSealedMutation();
  if (hashtable == null)   hashtable=new Hashtable();
  hashtable.put(key,value);
}
