/** 
 * Parser calls the method when it gets / or /= in literal context.
 */
void readRegExp(int startToken) throws IOException {
  stringBufferTop=0;
  if (startToken == Token.ASSIGN_DIV) {
    addToString('=');
  }
 else {
    if (startToken != Token.DIV)     Kit.codeBug();
  }
  int c;
  while ((c=getChar()) != '/') {
    if (c == '\n' || c == EOF_CHAR) {
      ungetChar(c);
      throw parser.reportError("msg.unterminated.re.lit");
    }
    if (c == '\\') {
      addToString(c);
      c=getChar();
    }
    addToString(c);
  }
  int reEnd=stringBufferTop;
  while (true) {
    if (matchChar('g'))     addToString('g');
 else     if (matchChar('i'))     addToString('i');
 else     if (matchChar('m'))     addToString('m');
 else     break;
  }
  if (isAlpha(peekChar())) {
    throw parser.reportError("msg.invalid.re.flag");
  }
  this.string=new String(stringBuffer,0,reEnd);
  this.regExpFlags=new String(stringBuffer,reEnd,stringBufferTop - reEnd);
}
