/** 
 * Report a runtime error using the error reporter for the current thread.
 * @param message the error message to report
 * @see org.mozilla.javascript.ErrorReporter
 */
public static EvaluatorException reportRuntimeError(String message){
  int[] linep={0};
  String filename=getSourcePositionFromStack(linep);
  return Context.reportRuntimeError(message,filename,linep[0],null,0);
}
