package rtp.result;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class FaultyTestCases {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static Map<String, Integer> getPosition (String ftResultPath, String ourResultPath) throws IOException {

		
		
		Map<String, String> ourResult = new HashMap<String, String>();
		
		Map<String, Integer> faultyTestCasesPos = new HashMap<String, Integer>();
		
		BufferedReader br = new BufferedReader(new FileReader(ourResultPath));
		String str = br.readLine();
		int i = 1;
		while(str!=null){
			String parts[] = str.split(" ");
			//System.out.print(++i+" "+parts[2]+" ");
			if(ourResult.containsKey(parts[2])){
				System.out.println("duplicate");
			}
			//System.out.println(parts[2]+ "\t"+i);
			ourResult.put(parts[2], ""+i);
			i++;
			str = br.readLine();
		}
		System.out.println("#tc:\t"+ourResult.size());
		br = new BufferedReader(new FileReader(ftResultPath));
		str = br.readLine();

		
		int t = 1;
		
		while(str!=null){
			String parts[] = str.split("-");
			String testCaseName = parts[0].substring(6);
			//System.out.println(testCaseName);
			if(ourResult.containsKey(testCaseName)){
				faultyTestCasesPos.put(""+t, Integer.parseInt(ourResult.get(testCaseName)));
				System.out.println(t+"\t"+ourResult.get(testCaseName));
			}else{
				//System.out.println(t+"\t"+10000);
			}
			t++;
			str = br.readLine();
		}
		System.out.println();
		return faultyTestCasesPos;

	}
	
public static Map<String, Integer> getPositionLingming (String ftResultPath, String ourResultPath, boolean print) throws IOException {

		
		
		Map<String, String> ourResult = new HashMap<String, String>();
		
		Map<String, Integer> faultyTestCasesPos = new HashMap<String, Integer>();
		
		BufferedReader br = new BufferedReader(new FileReader(ourResultPath));
		String str = br.readLine();
		int i = 1;
		while(str!=null){
			if(ourResult.containsKey(str)){
				System.out.println("duplicate");
			}
			//System.out.println(parts[2]+ "\t"+i);
			ourResult.put(str, ""+i);
			i++;
			str = br.readLine();
		}
		if(print)
			System.out.println("#tc:\t"+ourResult.size());
		br = new BufferedReader(new FileReader(ftResultPath));
		str = br.readLine();

		
		int t = 1;
		
		while(str!=null){
			String parts[] = str.split("-");
			String testCaseName = parts[0].substring(6);
			//System.out.println(testCaseName);
			if(ourResult.containsKey(testCaseName)){
				faultyTestCasesPos.put(""+t, Integer.parseInt(ourResult.get(testCaseName)));
				if(print) System.out.println(t+"\t"+ourResult.get(testCaseName));
			}else{
				//System.out.println(t+"\t"+10000);
			}
			t++;
			str = br.readLine();
		}
		if(print) System.out.println();
		return faultyTestCasesPos;

	}
	
public static Map<String, Integer> getClassPosition (String ftResultPath, String ourResultPath) throws IOException {

		
		
		Map<String, String> ourResult = new HashMap<String, String>();
		
		Map<String, Integer> faultyTestCasesPos = new HashMap<String, Integer>();
		
		BufferedReader br = new BufferedReader(new FileReader(ourResultPath));
		String str = br.readLine();
		int i = 1;
		while(str!=null){
			String parts[] = str.split(" ");
			//System.out.print(++i+" "+parts[2]+" ");
			if(ourResult.containsKey(parts[2])){
				System.out.println("duplicate");
			}
			//System.out.println(parts[2]+ "\t"+i);
			ourResult.put(parts[2], ""+i);
			i++;
			str = br.readLine();
		}
		System.out.println("#tc:\t"+ourResult.size()+"\t"+ourResultPath);
		br = new BufferedReader(new FileReader(ftResultPath));
		str = br.readLine();

		
		int t = 1;
		
		while(str!=null){
			String parts[] = str.split("-");
			String testCaseName = removeMethodName(parts[0].substring(6));
			//System.out.println(testCaseName);
			if(ourResult.containsKey(testCaseName)){
				faultyTestCasesPos.put(""+t, Integer.parseInt(ourResult.get(testCaseName)));
				System.out.println(t+"\t"+ourResult.get(testCaseName));
			}else{
				//System.out.println(t+"\t"+10000);
			}
			t++;
			str = br.readLine();
		}
		System.out.println();
		return faultyTestCasesPos;

	}

public static Map<String, Integer> getClassPositionLingming (String ftResultPath, String ourResultPath, boolean print) throws IOException {
	
	Map<String, String> ourResult = new HashMap<String, String>();
	
	Map<String, Integer> faultyTestCasesPos = new HashMap<String, Integer>();
	
	BufferedReader br = new BufferedReader(new FileReader(ourResultPath));
	String str = br.readLine();
	int i = 1;
	while(str!=null){
		//String parts[] = str.split(" ");
		//System.out.print(++i+" "+parts[2]+" ");
		if(ourResult.containsKey(str)){
			System.out.println("duplicate");
		}
		//System.out.println(parts[2]+ "\t"+i);
		ourResult.put(str, ""+i);
		i++;
		str = br.readLine();
	}
	if(print)
	System.out.println("#tc:\t"+ourResult.size()+"\t"+ourResultPath);
	br = new BufferedReader(new FileReader(ftResultPath));
	str = br.readLine();

	
	int t = 1;
	
	while(str!=null){
		String parts[] = str.split("-");
		String testCaseName = removeMethodName(parts[0].substring(6));
		//System.out.println(testCaseName);
		if(ourResult.containsKey(testCaseName)){
			faultyTestCasesPos.put(""+t, Integer.parseInt(ourResult.get(testCaseName)));
			if(print)
			System.out.println(t+"\t"+ourResult.get(testCaseName));
		}else{
			//System.out.println(t+"\t"+10000);
		}
		t++;
		str = br.readLine();
	}
	//System.out.println();
	return faultyTestCasesPos;

}

	static String removeMethodName(String testCaseName){
		String testClass = "";
		String parts[] = testCaseName.split("\\.");
		testClass = parts[0];
		for(int i = 1; i<parts.length-1; i++){
			testClass = testClass + "." + parts[i];
		}
		return testClass;
	}
	
	public static void main(String args[]){
		System.out.println(removeMethodName("com.domainlanguage.basic.IntervalTest.testIncludesInterval"));
	}

}
