package rtp.result;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rtp.utility.FileSystem;


public class MethodAPFDLingFinalSingleProgram {

	/**
	 * @param args
	 * @throws IOException 
	 */
	
	
	public static void main (String[] args) throws IOException {
		//FileSystem fs = new FileSystem();
		
		boolean print = true;
	//****	
		PrintStream out = new PrintStream(new FileOutputStream("/Users/ripon/RTS/master-tfidf-structured-distinct-hl-result-for-test-method-now.txt"));
		System.setOut(out);
		
		int n[] = {1698,1703,
				   637,698,768,885,924,1200,
				   219,1932,2420,2516,
				   143,159,
				   120,348,
				   24,69,243,645,
				   91};

		String ftResultPath[] = {"commons-lang3.02-commons-lang3.03-fault-info.data",
				                 "commons-lang3.03-commons-lang3.04-fault-info.data",
				                 
				                 "xstream1.20-xstream1.21-fault-info.data",
				                 "xstream1.21-xstream1.22-fault-info.data",
				                 "xstream1.22-xstream1.30-fault-info.data",
				                 "xstream1.30-xstream1.31-fault-info.data",
				                 "xstream1.31-xstream1.40-fault-info.data",
				                 "xstream1.41-xstream1.42-fault-info.data",
				                 
				                 "joda-time0.90-joda-time0.95-fault-info.data",
				                 "joda-time0.98-joda-time0.99-fault-info.data",
				                 "joda-time1.10-joda-time1.20-fault-info.data",
				                 "joda-time1.20-joda-time1.30-fault-info.data",
				                 
				                 "timeandmoney3.0-timeandmoney4.0-fault-info.data",
				                 "timeandmoney4.0-timeandmoney5.0-fault-info.data",
				                 
				                 "mime4j0.50-mime4j0.60-fault-info.data",
				                 "mime4j0.61-mime4j0.70-fault-info.data",
				                 
				                 "jaxen1.0b7-jaxen1.0b9-fault-info.data",
				                 "jaxen1.1b2-jaxen1.1b5-fault-info.data",
				                 "jaxen1.1b6-jaxen1.1b7-fault-info.data",
				                 "jaxen1.1b9-jaxen1.1b11-fault-info.data",
				                 
				                 "xmlsec1.0-xmlsec2.0-fault-info.data",	                 

		};
//****
		String base = "/Users/ripon/RTS/distinct-method-hl-filtered-structured/";

		String folder[] = {
		"commons-lang3.02",
		"commons-lang3.03",
		
		"xstream1.20",
		"xstream1.21",
		"xstream1.22",
		"xstream1.30",
		"xstream1.31",
		"xstream1.41",
		
		"joda-time0.90",
		"joda-time0.98",
		"joda-time1.10",
		"joda-time1.20",
		
		"timeandmoney3.0",
		"timeandmoney4.0",
		
		"mime4j0.50",
		"mime4j0.61",
		
		"jaxen1.0b7",
		"jaxen1.1b2",
		"jaxen1.1b6",
		"jaxen1.1b9",

		"Xmlsec1.0"};

		
		for(int s = 0; s < 21; s++){

		//String path = base + folder[s];
		String path = base;
		List<String> files = null;
		//files = FileSystem.getAllFiles(path, path.length()-1);
		
		//**for untreated test results
		files = new ArrayList<String>();
//****
		files.add(folder[s]+"-result_tfidf-distinct-hl-method-structured-filtered.txt");
		//
		
		double apfd[] = new double[files.size()];
		
		int f = 0;
		
		for(String file:files){
			//if(file.equals(".DS_Store")) continue;
		
				String ourResultPath = path+file;
		if(print){
		System.out.println(ftResultPath[s]);
		System.out.println(ourResultPath);
		System.out.println("-----------------------------------------------------------------------------------\n");
		}
		
		Map<String, List<Integer>> faults = new HashMap<String, List<Integer>>();
		
		BufferedReader br = new BufferedReader(new FileReader("/Users/ripon/RTS/fault-info/"+ftResultPath[s]));
		String str = br.readLine();
		
		int i = 1;
		
		Map<String, Integer> faultyTestCasesPos = FaultyTestCases.getPositionLingming("/Users/ripon/RTS/fault-info/"+ftResultPath[s], ourResultPath,print);
		
		while(str!=null){
			String parts[] = str.split("-");
			//String testCaseName = parts[0].substring(6);
			//System.out.println(testCaseName);
			String changes[] = parts[1].split(",");
			for(int j = 0; j<changes.length; j++){
				Integer pos = faultyTestCasesPos.get(""+i);
				if(pos != null){
					add(faults, changes[j], pos);
				}
			}
			str = br.readLine();
			i++;
		}
		
		br.close();
		
		apfd[f] = print(faults,n[s],print);
		f++;
		}
		
		DecimalFormat df = new DecimalFormat("#.##");
		if(print) 
		for(double apfd_cur: apfd){
			System.out.print(df.format(apfd_cur)+"\t");
		}
		
		double sum = 0;
		for(double apfd_cur: apfd){
			sum = sum + apfd_cur;
		}
		if(print){
		System.out.println("\n\nAverage:\t"+df.format(sum/apfd.length));
		}
		}

	}
	
	static void add(Map<String,List<Integer>> faults, String key, Integer str){
		if(faults.containsKey(key)){
			List<Integer> testCases = faults.get(key);
			testCases.add(str);
			faults.put(key, testCases);
		}
		else{
			List<Integer> testCases = new ArrayList<Integer>();
			testCases.add(str);
			faults.put(key, testCases);
		}
	}
	
	static double print(Map<String,List<Integer>> faults, int n,boolean print){
		int i = 0;
		int tf = 0;
		for (Map.Entry<String, List<Integer>> entry : faults.entrySet()) {
		    String key = entry.getKey();
		    //System.out.println("\t"+key+"--->"+faults.get(key)+"--->"+Collections.min(faults.get(key)));
		    int min = Collections.min(faults.get(key));
		    tf = tf + min;
			if(print)
		    System.out.println(++i+"\t"+faults.get(key)+"\t"+ min);
		}
		if(print)
		System.out.println();
		
		int nm = n*faults.size();
		if(print){
		System.out.println("tf\t"+tf);
		System.out.println("nm\t"+ nm);
		}
		
		double apfd = 1 - (double) tf / (double) nm + 1/(2*(double)n);
		if(print)
		System.out.println("APFD\t"+apfd+"\n\n");
		
		return apfd;
	}
}
