#!bin/sh
ant_dir="/Users/assist/dmz/ir-dataset/code/ant53"
log_dir="/Users/assist/dmz/src/rtp/DLo/amldata/ant_bugs_manager/test-log"
test_results_dir="/Users/assist/dmz/src/rtp/DLo/amldata/ant_bugs_manager/junit-test-results"

if [ -d "$log_dir" ]
then
    rm -rfv $log_dir/*
fi

if [ -d "$test_results_dir" ]
then
    rm -rfv $test_results_dir/*
fi

bugs=$(ls $ant_dir)

for b in $bugs
do
   # if [ -d "$test_results_dir/$b/test-report" ]
    #then
#	continue
    #   fi

    if [ $b != "ANT-39002" ]
    then
	continue	
    fi
    
    
    
    id="$b.xml"
    xml_file=$ant_dir/$b/post-fix/$id
    echo "running test in ... [$b]"
   
    cd "$ant_dir/$b/post-fix"
    

    ant -d -f $xml_file clean build compile-tests run-test > $log_dir/$b.txt
    

    mkdir "$test_results_dir/$b"
    cp -avR "$ant_dir/$b/post-fix/build/test-report" "$test_results_dir/$b"
done
