#!bin/sh
pre_post="post-fix"
bug_list="/Users/assist/dataset/TCM/DLo/amldata/bug_list/aspectj_bug_list.txt"
bug_list_compile_log="/Users/assist/dataset/TCM/DLo/amldata/bug_list/aspectj-compile-log/$pre_post"
ibugs_aj_dir="/Users/assist/tools/ibugs_aspectj-1.3"

bugs=$(cat $bug_list)

for b in $bugs
do
    id=$(echo "$b" | xargs)
#    ant -f "$ibugs_aj_dir/build.xml" checkoutversion -DfixId="$id"

    log=$(ant -f "$ibugs_aj_dir/build.xml" buildversion -DfixId="$id" -Dtag="$pre_post")
    echo "$log"
    echo "$log" | grep "BUILD FAILED"

    if [ $? != 0 ]
    then
	log=$(ant -f "$ibugs_aj_dir/build.xml" buildtests -DfixId="$id" -Dtag="$pre_post")
	echo "$log" | grep "BUILD FAILED"
	
	if [ $? != 0 ]
	then
	    echo "build and test are successful" > "$bug_list_compile_log/$b.txt"
	else
	    echo "build successful but compile test failed" > "$bug_list_compile_log/$b.txt"
	fi
    else
	echo "Build failed" > "$bug_list_compile_log/$b.txt"
    fi
done
       
