project="lucene37" # which project data set to get coverage data
pre_post="post-fix" # which version, either faulty or fixed

INPUT="/Users/assist/ndataset/dlo/projects/dataset/$project" # where project data classes are found
OUTDIR="/Users/assist/ndataset/dlo/projects/faulttracer-data/$project/$pre_post/coverage-data/method-cv" # coverage results dir
LOGDIR="/Users/assist/ndataset/dlo/projects/faulttracer-data/$project/$pre_post/log/method-cv" # the dir of logging the running of faulttracer

BUGS=$(ls $INPUT) # list of bug IDs

for i in $BUGS
do

    VERSION=$(ls $INPUT/$i | grep "$pre_post")
    if [ $? == 0 ]
    then
	echo "Collecting and Loading method coverage in: $INPUT/$i/$VERSION"
	XMLPATH="$INPUT/$i/$VERSION"
	xml_file="$XMLPATH/$i.faulttracer.xml"
	cd $XMLPATH
	if [ -f "$xml_file" ]
	then
	    if [ -d "$XMLPATH/faulttracer-files" ]
	    then
		echo "Wilord967!" | sudo -S rm -rf $XMLPATH/faulttracer-files
	    fi
	    
	    echo "Wilord967!" | sudo -S ant -d -f "$xml_file" collectMethodCoverage > $LOGDIR/$i.log
	    echo "Wilord967!" | sudo -S ant -f "$xml_file" loadMethodCoverage > $OUTDIR/$i.mcv

	    echo "[$i:$VERSION] ... [Done]"
	fi
    fi
    
done

