#!bin/sh

search_dir="/Users/assist/ndataset/dlo/projects/dataset/rhino"

bugs=$(ls $search_dir)

for b in $bugs
do
    if [[ ! $b == ".*" ]]
    then
	versions=$(ls $search_dir/$b)
	for v in $versions
	do
	    if [[ ! $v == .* ]]
	    then
		xml_file="$search_dir/$b/$v/xmlimplsrc/build.xml"
		echo "working on [$b] in [$xml_file]"
		
		sed -i -e 's/http:\/\/www.apache.org/http:\/\/archive.apache.org/g' $xml_file
		
		if  [[ $? == 0 ]]
		then
		    echo "[www.apache.org] not found in: $xml_file ... [NOT FOUND]"
		else
		    echo "[www.apache.org] in: $xml_file .... [FOUND successful]"
		fi

		sed -i -e 's/xbean.zip/xmlbeans-2.2.0.zip/g'
		if  [[ $? == 0 ]]
		then
		    echo "[xbean.zip] NOT FOUND  in: $xml_file ... [NOT FOUND]"
		else
		    echo "[xbean.zip] FOUND in: $xml_file .... [FOUND successful]"
		fi				
	    fi
	done
    fi
done

