private int addReservedCodeSpace(int size){
  if (itsCurrentMethod == null)   throw new IllegalArgumentException("No method to add to");
  int oldTop=itsCodeBufferTop;
  int newTop=oldTop + size;
  if (newTop > itsCodeBuffer.length) {
    int newSize=itsCodeBuffer.length * 2;
    if (newTop > newSize) {
      newSize=newTop;
    }
    byte[] tmp=new byte[newSize];
    System.arraycopy(itsCodeBuffer,0,tmp,0,oldTop);
    itsCodeBuffer=tmp;
  }
  itsCodeBufferTop=newTop;
  return oldTop;
}
