public Object compile(CompilerEnvirons compilerEnv,ScriptOrFnNode tree,String encodedSource,boolean returnFunction){
  int serial;
synchronized (globalLock) {
    serial=++globalSerialClassCounter;
  }
  String mainClassName="org.mozilla.javascript.gen.c" + serial;
  byte[] mainClassBytes=compileToClassFile(compilerEnv,mainClassName,tree,encodedSource,returnFunction);
  return new Object[]{mainClassName,mainClassBytes};
}
