/** 
 * If statement
 */
Node createIf(Node cond,Node ifTrue,Node ifFalse,int lineno){
  int condStatus=isAlwaysDefinedBoolean(cond);
  if (condStatus == ALWAYS_TRUE_BOOLEAN) {
    return ifTrue;
  }
 else   if (condStatus == ALWAYS_FALSE_BOOLEAN) {
    if (ifFalse != null) {
      return ifFalse;
    }
    return new Node(Token.BLOCK,lineno);
  }
  Node result=new Node(Token.BLOCK,lineno);
  Node ifNotTarget=Node.newTarget();
  Node.Jump IFNE=new Node.Jump(Token.IFNE,cond);
  IFNE.target=ifNotTarget;
  result.addChildToBack(IFNE);
  result.addChildrenToBack(ifTrue);
  if (ifFalse != null) {
    Node endTarget=Node.newTarget();
    result.addChildToBack(makeJump(Token.GOTO,endTarget));
    result.addChildToBack(ifNotTarget);
    result.addChildrenToBack(ifFalse);
    result.addChildToBack(endTarget);
  }
 else {
    result.addChildToBack(ifNotTarget);
  }
  return result;
}
