private Node createMemberRefGet(Node target,String namespace,Node elem,int memberTypeFlags){
  Node nsNode=null;
  if (namespace != null) {
    if (namespace.equals("*")) {
      nsNode=new Node(Token.NULL);
    }
 else {
      nsNode=createName(namespace);
    }
  }
  Node ref;
  if (target == null) {
    if (namespace == null) {
      ref=new Node(Token.REF_NAME,elem);
    }
 else {
      ref=new Node(Token.REF_NS_NAME,nsNode,elem);
    }
  }
 else {
    if (namespace == null) {
      ref=new Node(Token.REF_MEMBER,target,elem);
    }
 else {
      ref=new Node(Token.REF_NS_MEMBER,target,nsNode,elem);
    }
  }
  if (memberTypeFlags != 0) {
    ref.putIntProp(Node.MEMBER_TYPE_PROP,memberTypeFlags);
  }
  return new Node(Token.GET_REF,ref);
}
