private static XMLLib currentXMLLib(Context cx){
  if (cx.topCallScope == null)   throw new IllegalStateException();
  XMLLib xmlLib=cx.cachedXMLLib;
  if (xmlLib == null) {
    xmlLib=XMLLib.extractFromScope(cx.topCallScope);
    if (xmlLib == null)     throw new IllegalStateException();
    cx.cachedXMLLib=xmlLib;
  }
  return xmlLib;
}
