/** 
 * A labelled statement implies that there maybe a break to the label. The function processes the labelled statement and then checks the CONTROL_BLOCK_PROP property to see if there is ever a break to the particular label.
 * @return logical OR of END_* flags
 */
private int endCheckLabel(){
  int rv=END_UNREACHED;
  rv=next.endCheck();
  rv|=getIntProp(CONTROL_BLOCK_PROP,END_UNREACHED);
  return rv;
}
