static boolean eqNumber(double x,Object y){
  for (; ; ) {
    if (y == null || y == Undefined.instance) {
      return false;
    }
 else     if (y instanceof Number) {
      return x == ((Number)y).doubleValue();
    }
 else     if (y instanceof String) {
      return x == toNumber(y);
    }
 else     if (y instanceof Boolean) {
      return x == (((Boolean)y).booleanValue() ? 1.0 : +0.0);
    }
 else     if (y instanceof Scriptable) {
      if (y instanceof ScriptableObject) {
        Object xval=wrapNumber(x);
        Object test=((ScriptableObject)y).equivalentValues(xval);
        if (test != Scriptable.NOT_FOUND) {
          return ((Boolean)test).booleanValue();
        }
      }
      y=toPrimitive(y);
    }
 else {
      warnAboutNonJSObject(y);
      return false;
    }
  }
}
