private void generateFunctionAndThisObj(Node node,Node parent){
  int type=node.getType();
switch (node.getType()) {
case Token.GETPROPNOWARN:
    throw Kit.codeBug();
case Token.GETPROP:
case Token.GETELEM:
{
    Node target=node.getFirstChild();
    generateExpression(target,node);
    Node id=target.getNext();
    if (type == Token.GETPROP) {
      String property=id.getString();
      cfw.addPush(property);
      cfw.addALoad(contextLocal);
      addScriptRuntimeInvoke("getPropFunctionAndThis","(Ljava/lang/Object;" + "Ljava/lang/String;" + "Lorg/mozilla/javascript/Context;"+ ")Lorg/mozilla/javascript/Callable;");
    }
 else {
      if (node.getIntProp(Node.ISNUMBER_PROP,-1) != -1)       throw Codegen.badTree();
      generateExpression(id,node);
      cfw.addALoad(contextLocal);
      addScriptRuntimeInvoke("getElemFunctionAndThis","(Ljava/lang/Object;" + "Ljava/lang/Object;" + "Lorg/mozilla/javascript/Context;"+ ")Lorg/mozilla/javascript/Callable;");
    }
    break;
  }
case Token.NAME:
{
  String name=node.getString();
  cfw.addPush(name);
  cfw.addALoad(contextLocal);
  cfw.addALoad(variableObjectLocal);
  addScriptRuntimeInvoke("getNameFunctionAndThis","(Ljava/lang/String;" + "Lorg/mozilla/javascript/Context;" + "Lorg/mozilla/javascript/Scriptable;"+ ")Lorg/mozilla/javascript/Callable;");
  break;
}
default :
generateExpression(node,parent);
cfw.addALoad(contextLocal);
addScriptRuntimeInvoke("getValueFunctionAndThis","(Ljava/lang/Object;" + "Lorg/mozilla/javascript/Context;" + ")Lorg/mozilla/javascript/Callable;");
break;
}
cfw.addALoad(contextLocal);
addScriptRuntimeInvoke("lastStoredScriptable","(Lorg/mozilla/javascript/Context;" + ")Lorg/mozilla/javascript/Scriptable;");
}
