/** 
 * If initCause methods exists in Throwable, call <tt>ex.initCause(cause)</tt> or otherwise do nothing.
 * @return The <tt>ex</tt> argument.
 */
public static RuntimeException initCause(RuntimeException ex,Throwable cause){
  if (Throwable_initCause != null) {
    Object[] args={cause};
    try {
      Throwable_initCause.invoke(ex,args);
    }
 catch (    Exception e) {
    }
  }
  return ex;
}
