/** 
 * Delegates to
 * @return true iff rhs appears in lhs' proto chain
 */
public static boolean jsDelegatesTo(Scriptable lhs,Scriptable rhs){
  Scriptable proto=lhs.getPrototype();
  while (proto != null) {
    if (proto.equals(rhs))     return true;
    proto=proto.getPrototype();
  }
  return false;
}
