/** 
 * Operator new. See ECMA 11.2.2
 */
public static Scriptable newObject(Object fun,Context cx,Scriptable scope,Object[] args){
  if (!(fun instanceof Function)) {
    throw notFunctionError(fun);
  }
  Function function=(Function)fun;
  return function.construct(cx,scope,args);
}
