private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
  in.defaultReadObject();
  int writtenKeyCount=keyCount;
  if (writtenKeyCount != 0) {
    keyCount=0;
    int N=1 << power;
    keys=new Object[N];
    values=new int[2 * N];
    for (int i=0; i != writtenKeyCount; ++i) {
      Object key=in.readObject();
      int hash=key.hashCode();
      int index=insertNewKey(key,hash);
      values[index]=in.readInt();
    }
  }
}
