private Node simpleAssignment(Node left,Node right){
  int nodeType=left.getType();
switch (nodeType) {
case Token.NAME:
    left.setType(Token.BINDNAME);
  return new Node(Token.SETNAME,left,right);
case Token.GETPROP:
case Token.GETELEM:
{
  Node obj=left.getFirstChild();
  Node id=left.getLastChild();
  int type;
  if (nodeType == Token.GETPROP) {
    type=Token.SETPROP;
  }
 else {
    type=Token.SETELEM;
  }
  return new Node(type,obj,id,right);
}
case Token.GET_REF:
{
Node ref=left.getFirstChild();
checkMutableReference(ref);
return new Node(Token.SET_REF,ref,right);
}
}
throw Kit.codeBug();
}
