/** 
 * The typeof operator
 */
public static String typeof(Object value){
  if (value == null)   return "object";
  if (value == Undefined.instance)   return "undefined";
  if (value instanceof Scriptable) {
    if (value instanceof ScriptableObject && ((ScriptableObject)value).avoidObjectDetection()) {
      return "undefined";
    }
    if (value instanceof XMLObject)     return "xml";
    return (value instanceof Callable) ? "function" : "object";
  }
  if (value instanceof String)   return "string";
  if (value instanceof Number)   return "number";
  if (value instanceof Boolean)   return "boolean";
  throw errorWithClassName("msg.invalid.type",value);
}
