private void writeObject(ObjectOutputStream out) throws IOException {
  out.defaultWriteObject();
  int count=keyCount;
  for (int i=0; count != 0; ++i) {
    Object key=keys[i];
    if (key != null && key != DELETED) {
      --count;
      out.writeObject(key);
      out.writeInt(values[i]);
    }
  }
}
