package rtp.extractor;

public class PreProcessor {

	public static String process1(String query){
		String processedQuery = "";
		query = query.replaceAll("[^\\p{L}\\p{N}]", " ");
		String words[] = query.split(" ");

		for(int i = 0; i<words.length; i++){
			if(words[i].length()>2&&!words[i].matches(".*\\d+.*"))
				processedQuery = processedQuery.trim() +" "+ words[i];
		}

		return processedQuery;
	}

	public static String process(String query){
		if(query==null)
			return "";
		String processedQuery = "";
		try {

			query = query.replaceAll("[^\\p{L}\\p{N}]", " ");
		} catch (Exception e) {
			System.out.println(query);
		}
		String words[] = query.split(" ");

		for(int i = 0; i<words.length; i++){
			if(words[i].length()>2&&!words[i].matches(".*\\d+.*"))
				processedQuery = processedQuery.trim() +" "+ transform(words[i]);
		}

		return processedQuery;
	}

	public static String transform(String name){
//		if(name.contains("Helles�a")){
//			System.out.println("Helles�a");
//			if(!isLegalString("Helles�a")){
//				System.out.println("Helles�a");
//			}
//		}
		
		if ((name == null) || (name.isEmpty())) {
			return "";
		}
		
		//camelCase to Spaced and then split into words
		String processedName[] =  name.replaceAll(
				String.format("%s|%s|%s",
						"(?<=[A-Z])(?=[A-Z][a-z])",
						"(?<=[^A-Z])(?=[A-Z])",
						"(?<=[A-Za-z])(?=[^A-Za-z])"
						),
						" "
				).toLowerCase().split(" ");

		String transformedString = "";



		for(String word:processedName){
			boolean legalCheck = isLegalString(word);
			if(word.length()>2&&legalCheck){
				transformedString = transformedString.trim() + " "+ word.trim();
			}

		}
		return transformedString;

	}

	public static String transform1(String name){		   
		String processedName[] =  name.replaceAll(
				String.format("%s|%s",
						"(?<=[A-Z])(?=[A-Z][a-z])",
						"(?<=[^A-Z])(?=[A-Z])"
						),
						" "
				).toLowerCase().split(" ");

		String transformedString = "";

		for(String word:processedName){
			if(word.length()>2){
				transformedString = transformedString + " "+ word;
			}
		}
		return transformedString;		   
	}

	static boolean isLegalString(String word){
		char letters[] = word.toCharArray();
		for(char ch:letters){
			if(!((ch>='a'&&ch<='z')||Character.isDigit(ch))){
				return false;
			}
		}
		return true;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		String str = "CvvvvLabelTestCase";
		System.out.println(transform(str));

	}

}
