#!bin/sh
xml_dir="/Users/assist/dataset/TCM/DLo/amldata/ant_bugs_manager/xml"
failed_test_dir="/Users/assist/dataset/TCM/DLo/amldata/failed_tests/ant"

bugs=$(ls $failed_test_dir)

for b in $bugs
do
    id=$(echo $b | cut -f 1 -d ".")
    test_names=$(cut -f 1 -d ":" $failed_test_dir/$id.txt | sort | uniq)

    for t in $test_names
    do
	echo "<test name=\"$t\" haltonfailure=\"no\" todir=\"\${test.report}\">" >> "$xml_dir/$id.xml"
	echo "<formatter type=\"xml\"/>" >> "$xml_dir/$id.xml"
	echo "<formatter type=\"plain\"/>" >> "$xml_dir/$id.xml"
	echo "</test>" >> "$xml_dir/$id.xml"
    done
    echo "</junit>" >> "$xml_dir/$id.xml"
    echo "</target>" >> "$xml_dir/$id.xml"
    echo "</project>" >> "$xml_dir/$id.xml"
done
