INPUT="/Users/assist/dataset/TCM/DLo/amldata/fixed_versions_list/ant/revs_full"
OUTPUT_DIR="/Users/assist/ndataset/dlo/projects/dataset/ant53"

if [ ! -d $OUTPUT_DIR ]
then
    mkdir "$OUTPUT_DIR" 
fi

while IFS='' read -r line || [[ -n "$line" ]]; do
    BUGID=$(echo $line | cut -f1 -d ":" | xargs)
    PREV=$(echo $line | cut -f2 -d ":" | cut -f2 -d "r" | xargs)
    REV=$(echo $line | cut -f3 -d ":" | cut -f2 -d "r" | xargs)

    mkdir "$OUTPUT_DIR/$BUGID"
    cd  "$OUTPUT_DIR/$BUGID"
    svn checkout -r $REV http://svn.apache.org/repos/asf/ant/core/trunk post-fix
    echo "[checkout fixed $REV] ... [ok]"

    svn checkout -r $PREV http://svn.apache.org/repos/asf/ant/core/trunk pre-fix
    echo "[checkout faulty $PREV] ... [ok]"

    
done < "$INPUT"

