project="ant" # which project data set to get coverage data
pre_post="faulty" # which version, either faulty or fixed

INPUT="/Users/assist/ndataset/dlo/projects/$project" # where project data classes are found
OUTDIR="/Users/assist/ndataset/dlo/projects/coverage-data/$project/$pre_post/method-cv" # coverage results dir
LOGDIR="/Users/assist/ndataset/dlo/projects/covering-log/$project/$pre_post/method-cv" # the dir of logging the running of faulttracer

BUGS=$(ls $INPUT) # list of bug IDs

for i in $BUGS
do

    VERSION=$(ls $INPUT/$i | grep "$pre_post")
    if [ $? == 0 ]
    then
	echo "Collecting and Loading method coverage in: $INPUT/$i/$VERSION"
	XMLPATH=$INPUT/$i/$VERSION
	cd $XMLPATH
	if [ -f $XMLPATH/faulttracer-config-junit4.xml ]
	then
	    if [ -d "$XMLPATH/faulttracer-files" ]
	    then
		echo "Wilord967!" | sudo -S rm -rfv $XMLPATH/faulttracer-files
	    fi
	    
	    echo "Wilord967!" | sudo -S ant -f $XMLPATH/faulttracer-config-junit4.xml collectMethodCoverage > $LOGDIR/$i.txt
	    echo "Wilord967!" | sudo -S ant -f $XMLPATH/faulttracer-config-junit4.xml loadMethodCoverage > $OUTDIR/$i.txt

	    echo "[$i:$VERSION] ... [Done]"
	fi
    fi
done

