#!/usr/bin/ruby
require 'fileutils'
require_relative 'main.rb'

failed_tests_dir = "/Users/assist/dmz/src/rtp/DLo/amldata/test_cases_list"
extracted_failed_tests_dir = "/Users/assist/dmz/src/rtp/DMZ/failed_tests"

project = ARGV[0]
puts "extracting failed tests for the project #{project}"

if ! File.directory?(failed_tests_dir + "/" + project)
  puts "[error] incorrect project name"
  exit
end

if ! File.directory?(extracted_failed_tests_dir + "/" + project)  
  FileUtils.mkdir_p(extracted_failed_tests_dir + "/" + project)
  puts "[info] #{extracted_failed_tests_dir + "/" + project} created [ok]"
end

Helper.extract_failed_tests(failed_tests_dir + "/" + project, extracted_failed_tests_dir + "/" + project)
