#!bin/sh
lucene_dir="/Users/assist/ndataset/dlo/projects/dataset/lucene37"
log_dir="/Users/assist/dataset/TCM/DLo/amldata/lucene_bugs_manager/test-log"
test_results_dir="/Users/assist/dataset/TCM/DLo/amldata/lucene_bugs_manager/junit-test-results"

bugs=$(ls $lucene_dir)

for b in $bugs
do
    if [ $b != "LUCENE-588" ]
    then
	continue
    fi
    
    id="$b.xml"
    xml_file=$lucene_dir/$b/post-fix/$id
    echo "running test in ... [$b]"
    echo "Wilord967!" | sudo -S ant -d -f $xml_file run-test > $log_dir/$b.txt
    mkdir $test_results_dir/$b
    cp -avR $lucene_dir/$b/post-fix/lucene/build/classes/test/test-report $test_results_dir/$b
done
