#!bin/sh
rhino_dir="/Users/assist/ndataset/dlo/projects/dataset/rhino"
log_dir="/Users/assist/dataset/TCM/DLo/amldata/bugs_manager/rhino_test_log"
test_results_dir="/Users/assist/dataset/TCM/DLo/amldata/bugs_manager/junit_test_results"

rm -rvf $log_dir/*
rm -rvf $test_results_dir/*

bugs=$(ls $rhino_dir)

for b in $bugs
do
    id=RHINO-$b.xml    
    xml_file=$rhino_dir/$b/post-fix/$id
    echo "running test in ... [$b]"
    echo "Wilord967!" | sudo -S ant -f $xml_file clean run-test > $log_dir/$b.txt
    mkdir $test_results_dir/$b
    cp -avR $rhino_dir/$b/post-fix/build/test/test-report $test_results_dir/$b
done


