project="$1"

buglocator_path="/Users/assist/dmz/tools/BugLocator"
code_dir="/Users/assist/dmz/ir-dataset/code/$project"
xml_dir="/Users/assist/dmz/ir-dataset/bugs-xml-repository3/$project"

output_dir="/Users/assist/dmz/gen-data/buglocator1/$project"

if [ ! -d $output_dir ]
then
    mkdir $output_dir
fi


bugs=$(ls $xml_dir)

for b in $bugs
do
    echo "Working on $b"
    id=$(echo $b | cut -d "." -f 1)
    if [ ! $id == "ASPECTJ-100227" ]
    then
	continue
    fi
    
    cd $buglocator_path
    java -jar BugLocator.jar -b "$xml_dir/$b" -s "$code_dir/$id/pre-fix/org.aspectj.modules/tests" -a 0.2 -o "$output_dir/$id.txt"
done




